/**
 * PersistentBoolean.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto:hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package goodslib;

import goodsjpi.*;

public class PersistentBoolean extends Persistent implements PersistentPrimary, Comparable {
    boolean value;
    transient Boolean objvalue;


    public PersistentBoolean (Boolean v){
	this.value=v.booleanValue();
	objvalue=v;
    }

    public PersistentBoolean (boolean v){
	this.value=v;
	objvalue=new Boolean(v);
    }

    protected void onLoad() {
	objvalue=new Boolean(value);
    }

    public int compareTo(Object o) {
	return PersistentPrimaryHelper.compareTo(this,o);
    }

    public boolean equals(Object o) {
	return PersistentPrimaryHelper.equals(this,o);
    }

    public int hashCode() {
	return getObjectValue().hashCode();
    }
    
    public boolean getValue() {
	return value;
    }
    
    public Object getObjectValue() {
	return objvalue;
    }
}// PersistentBoolean
