/**
 * PersistentChar.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto:hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package goodslib;

import goodsjpi.*;

public class PersistentChar extends Persistent implements PersistentPrimary, Comparable {
    char value;
    transient Character objvalue;

    public PersistentChar (Character v){
	this.value=v.charValue();
	objvalue=v;
    }

    public PersistentChar (char v){
	this.value=v;
	objvalue=new Character(v);
    }
    
    public char getValue() {
	return value;
    }
    
    public Object getObjectValue() {
	return objvalue;
    }

    public int compareTo(Object o) {
	return PersistentPrimaryHelper.compareTo(this,o);
    }

    public boolean equals(Object o) {
	return PersistentPrimaryHelper.equals(this,o);
    }

    public int hashCode() {
	return getObjectValue().hashCode();
    }
}// PersistentChar
