/**
 * PersistentPrimaryMapper.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto:hotari@iki.fi">Lari Hotari</a>
 * @version
 */
package goodslib;
import  goodsjpi.*;

public class PersistentMapper {
    public static Object mapPersistentToObject(Object persistent) {
	if(persistent instanceof Persistent) {
	    return mapPersistentToObject((Persistent)persistent);
	} else {
	    return persistent;
	}
    }

    public static Object mapPersistentToObject(Persistent persistent) {
	if(persistent==null) return null;
	if(persistent instanceof PersistentPrimary) {
	    return ((PersistentPrimary)persistent).getObjectValue();
	} else {
	    return persistent;
	}
    }

    public static Persistent mapObjectToPersistent(Object primary) {
	Persistent persistent;

	if(primary==null) return null;

	if(primary instanceof Persistent) {
	    persistent=(Persistent)primary;
	} else if(primary instanceof String) {
	    persistent=new PersistentString((String)primary);
	} else if (primary instanceof Integer) {
	    persistent=new PersistentInt((Integer)primary);
	} else if (primary instanceof Long) {
	    persistent=new PersistentLong((Long)primary);
	} else if (primary instanceof Short) {
	    persistent=new PersistentShort((Short)primary);
	} else if (primary instanceof Double) {
	    persistent=new PersistentDouble((Double)primary);
	} else if (primary instanceof Float) {
	    persistent=new PersistentFloat((Float)primary);
	} else if (primary instanceof Character) {
	    persistent=new PersistentChar((Character)primary);
	} else if (primary instanceof Byte) {
	    persistent=new PersistentByte((Byte)primary);
	} else if (primary instanceof Boolean) {
	    persistent=new PersistentBoolean((Boolean)primary);
	} else {
	    persistent=new PersistentObject(primary);
	}
	return persistent;
    }
    
}// PersistentPrimaryMapper
