/**
 * PersistentShort.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto:hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package goodslib;

import goodsjpi.*;

public class PersistentShort extends PersistentNumber {
    short value;
    transient Short objvalue;

    public PersistentShort (Short v){
	this.value=v.shortValue();
	objvalue=v;
    }

    public PersistentShort (short v){
	this.value=v;
    	objvalue=new Short(v);
    }

    protected void onLoad() {
	objvalue=new Short(value);
    }
    
    public short getValue() {
	return value;
    }
    
    public Object getObjectValue() {
	return objvalue;
    }

    public boolean equals(Object o) {
	if(o==this) return true;
	if(o==null) {
	    return false;
	}
	if(o instanceof PersistentShort) {
	    short myval=getValue();
	    short otherval=((PersistentShort)o).getValue();
	    if(otherval==myval)
		return true;
	}
	return false;
    }

    public int hashCode() {
	return (int)getValue();
    }
}// PersistentShort
