package goodslib;
import  goodsjpi.*;

public class PersistentString extends Persistent implements Comparable, PersistentPrimary { 
    String objvalue;

    public PersistentString(String str) { 
	   objvalue=str;
    }

    public String toString() {
	return objvalue;
    }

    public int compareTo(Object o) {
	if(objvalue==null) {
	    return -1;
	}
	if(o==null) {
	    return 1;
	}
	String otherstr=null;
	if(o instanceof PersistentString) {
	    otherstr=((PersistentString)o).getValue();
	} else if(o instanceof String) {
	    otherstr=(String)o;
	} else {
	    otherstr=String.valueOf(o);
	}
	if(otherstr==null) {
	    return 1;
	}
	return objvalue.compareTo(otherstr);
    }

    public String getValue() {
	return objvalue;
    }

    public Object getObjectValue() {
	return objvalue;
    }

    public boolean equals(Object o) {
	if(o==this) return true;
	if(o==null) {
	    return false;
	}
	if(o instanceof PersistentString) {
	    String myval=getValue();
	    String otherval=((PersistentString)o).getValue();
	    if(otherval==null && myval==null)
		return true;
	    if(otherval==null || myval==null)
		return false;
	    if(myval != null && otherval.equals(myval))
		return true;
	}
	return false;
    }

    public int hashCode() {
	Object myval=getValue();
	if(myval != null) {
	    return myval.hashCode();
	} else {
	    return super.hashCode();
	}
    }
}




