package goodsutil;
/**
 * GoodsRemoteServer.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto:hotari@iki.fi">Lari Hotari</a>
 * @version
 */

import java.util.*;
import java.io.File;

public class GoodsRemoteServer implements GoodsServer {
    Properties goodsprops;
    File[] dbdirs;
    String dbname;
    GoodsConfig[] srvconfig;
    GoodsDbConfig[] dbconfig;
    GoodsServerTelnetInterface[] telnetif;
    
    public GoodsRemoteServer (String dbname, Properties goodsprops, File[] dbdirs) {
	this.dbdirs=dbdirs;
	this.dbname=dbname;
	this.goodsprops=goodsprops;
	srvconfig=new GoodsConfig[dbdirs.length];
	dbconfig=new GoodsDbConfig[dbdirs.length];
	telnetif=new GoodsServerTelnetInterface[dbdirs.length];
	for(int i=0;i < dbdirs.length;i++) {
	    dbconfig[i]=new GoodsDbConfig(new File(dbdirs[i], dbname + ".cfg"));
	    srvconfig[i]=new GoodsConfig(new File(dbdirs[i], "goodsrv.cfg"));
	    telnetif[i]=new GoodsServerTelnetInterface(srvconfig[i].getProperty(GoodsConfig.SERVER_ADMIN_TELNET_PORT));
	}
    }

    public void stop() throws Exception {
	//executeCommand("exit");
    }

    public synchronized String executeCommand(int snum, String command) {
	String response=null;
	try {
	    telnetif[snum].connect();
	    telnetif[snum].executeCommand(command);
	    telnetif[snum].close();
	} catch (Exception e) {
	}
	return response;
    }

    public synchronized String executeCommand(String command) {
	if(dbdirs.length > 1) {
	    StringBuffer sb=new StringBuffer();
	    for(int i=0;i < dbdirs.length;i++) {
		sb.append("<serverresponse snum=\"").append(i).append("\">\n");
		sb.append(executeCommand(i, command));
		sb.append("<serverresponse />\n");
	    }
	    return sb.toString();
	} else {
	    return executeCommand(0, command);
	}
    }
}// GoodsRemoteServer
