
/**
 * $Id: AbstractAdapter.java,v 1.1 2001/10/04 14:52:04 lari Exp $
 * AbstractAdapter.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto: hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package oodblib.adapter;

import java.util.*;
import oodblib.*;
import java.io.*;

public abstract class AbstractAdapter implements Serializable {
    protected boolean convertdataobjects=true;
    transient protected ObjectMapper mapper;

    public void writeObject(ObjectOutputStream out) throws IOException {
	out.writeBoolean(convertdataobjects);
    }

    public void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
	convertdataobjects=in.readBoolean();
    }

    public AbstractAdapter (ObjectMapper mapper){
	this.mapper=mapper;
    }

    public void resume(ObjectMapper mapper) {
	this.mapper=mapper;
    }

    public Object toPersistentObject(Object obj) {
	if(convertdataobjects) {
	    return mapper.mapNormalToData(obj);
	} else {
	    return obj;
	}
    }
    
    public Object toNormalObject(Object obj) {
	if(convertdataobjects) {	
	    if(obj instanceof Map.Entry) {
		return new MapEntryAdapter((Map.Entry)obj,this);
	    }
	    return mapper.mapDataToNormal(obj);
	} else {
	    return obj;
	}
    }

    public ObjectMapper getFactory() {
	return mapper;
    }
}// AbstractAdapter

