 
/**
 * $Id: CollectionAdapter.java,v 1.1 2001/10/04 14:52:04 lari Exp $
 * CollectionAdapter.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto: hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package oodblib.adapter;

import java.util.*;
import oodblib.*;

public class CollectionAdapter implements Collection, Set {
    Collection collection;
    AbstractAdapter adapter;

    public CollectionAdapter(Collection collection, AbstractAdapter adapter) {
	this.collection=collection;
	this.adapter=adapter;
    }
    
    public boolean add(Object o) {
	return collection.add(adapter.toPersistentObject(o));
    }
    

    public int size() {
	return collection.size();
    }
    
    
    public boolean isEmpty() {
	return collection.isEmpty();
    }
    
    
    public boolean contains(Object o) {
	return collection.contains(adapter.toPersistentObject(o));
    }
    
    
    public Iterator iterator() {
	return new IteratorAdapter(collection.iterator(),adapter);
    }
     
    public Object[] toArray() {
	Object[] dataobjs=collection.toArray();
	Object[] objs=(Object [])dataobjs.clone();
	for(int i=0;i < dataobjs.length;i++) {
	    objs[i]=adapter.toNormalObject(dataobjs[i]);
	}
	return objs;
    }

    public Object[] toArray(Object[] a) {
	Object[] dataobjs=collection.toArray(a);
	Object[] objs=(Object [])dataobjs.clone();
	for(int i=0;i < dataobjs.length;i++) {
	    objs[i]=adapter.toNormalObject(dataobjs[i]);
	}
	return objs;
    }
    
    public boolean remove(Object o) {
	return collection.remove(adapter.toPersistentObject(o));
    }

    private Collection convertCollection2Data(Collection c) {
	ArrayList newc=new ArrayList();
	Object[] dataobjs=c.toArray();
	for(int i=0;i < dataobjs.length;i++) {
	    newc.add(adapter.toPersistentObject(dataobjs[i]));
	}
	return newc;
    }
        
    public boolean containsAll(Collection c) {
	return collection.containsAll(convertCollection2Data(c));
    }
        
    public boolean addAll(Collection c) {
	return collection.addAll(convertCollection2Data(c));
    }
    
    
    public boolean removeAll(Collection c) {
	return collection.removeAll(convertCollection2Data(c));
    }
    
    
    public boolean retainAll(Collection c) {
	return collection.retainAll(convertCollection2Data(c));
    }
    
    
    public void clear() {
	collection.clear();
    }
}
// CollectionAdapter
