
/**
 * $Id: ListIteratorAdapter.java,v 1.1 2001/10/04 14:52:04 lari Exp $
 * ListIteratorImpl.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto: hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package oodblib.adapter;

import java.util.*;
import oodblib.*;

public class ListIteratorAdapter implements ListIterator {
    ListIterator iterator;
    AbstractAdapter adapter;

    public ListIteratorAdapter(ListIterator iterator, AbstractAdapter adapter) {
	this.iterator=iterator;
	this.adapter=adapter;
    }
    
    public boolean hasNext() {
	return iterator.hasNext();
    }
    
    public Object next() {
	return adapter.toNormalObject(iterator.next());	
    }

    public void remove() {
	iterator.remove();
    } 

    public boolean hasPrevious() {
	return iterator.hasPrevious();
    }

    public Object previous() {
	return adapter.toNormalObject(iterator.previous());
    }

    public int nextIndex() {
	return iterator.nextIndex();
    }

    public int previousIndex() {
	return iterator.previousIndex();
    }

    public void set(Object o) {
	iterator.set(adapter.toPersistentObject(o));
   }

    public void add(Object o) {
	iterator.add(adapter.toPersistentObject(o));
    }
}// ListIteratorImpl
