
/**
 * $Id: MapEntryAdapter.java,v 1.1 2001/10/04 14:52:04 lari Exp $
 * MapEntryAdapter.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto: hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package oodblib.adapter;

import java.util.*;
import oodblib.*;

public class MapEntryAdapter implements Map.Entry {
    Map.Entry entry;
    transient AbstractAdapter adapter;

    public MapEntryAdapter (Map.Entry entry, AbstractAdapter adapter){
	this.entry=entry;
	this.adapter=adapter;
    }

    public Object getKey() {
	try {
	    return adapter.toNormalObject(entry.getKey());
	} catch (Exception e) {
	    e.printStackTrace(System.err);
	    return null;
	}
    }
    
    public Object getValue() {
	try {
	    return adapter.toNormalObject(entry.getValue());
	} catch (Exception e) {
	    e.printStackTrace(System.err);
	    return null;
	}
    }
    
    public Object setValue(Object value) {
	return adapter.toNormalObject(entry.setValue(adapter.toPersistentObject(value)));
    }
}// MapEntryAdapter
