
/**
 * $Id: SortedSetAdapter.java,v 1.1 2001/10/04 14:52:04 lari Exp $
 * SortedSetAdapter.java
 *
 *
 * Created: Tue Dec  4 12:06:41 2001
 *
 * @author <a href="mailto: hotari@iki.fi">Lari Hotari</a>
 * @version
 */

package oodblib.adapter;

import java.util.*;
import java.io.*;

public class SortedSetAdapter extends AbstractAdapter implements java.util.SortedSet, MappedObject, Serializable {
    static final long serialVersionUID = 1899341751681060245L; //Generated by jserial
    transient private SortedSet datasortedset;

    public void writeObject(ObjectOutputStream out) throws IOException {
	super.writeObject(out);
	if(datasortedset instanceof java.io.Serializable) {
	    out.writeObject(datasortedset);
	} else {
	    out.writeObject(null);
	}
    }

    public void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
	super.readObject(in);
	datasortedset=(SortedSet)in.readObject();
    }

    public SortedSetAdapter (ObjectMapper mapper, SortedSet datasortedset) {
	super(mapper);
	this.datasortedset=datasortedset;
	this.convertdataobjects=true;
	mapper.registerObject(this);
    }

    public SortedSetAdapter (ObjectMapper mapper, SortedSet datasortedset, boolean convertdataobjects) {
	super(mapper);
	this.datasortedset=datasortedset;
	this.convertdataobjects=convertdataobjects;
	mapper.registerObject(this);
    }

    public Object getDataObject() {
	return datasortedset;
    }

    public boolean add(Object o) {
	return datasortedset.add(toPersistentObject(o));
    }

    public boolean addAll(Collection c) {
	for(Iterator it=c.iterator();it.hasNext();) {
	    datasortedset.add(toPersistentObject(it.next()));
	}
	return true;
    }
	
    public void clear() {
	datasortedset.clear();
    }
   
    public boolean contains(Object elem) {
	return datasortedset.contains(toPersistentObject(elem));
    }

    public boolean isEmpty() {
	return datasortedset.isEmpty();
    }

    public int size() {
	return datasortedset.size();
    }

    public Object[] toArray() {
	Object[] dataobjs=datasortedset.toArray();
	Object[] objs=(Object [])dataobjs.clone();
	for(int i=0;i < dataobjs.length;i++) {
	    objs[i]=toNormalObject(dataobjs[i]);
	}
	return objs;
    }

    public Object[] toArray(Object[] a) {
	Object[] dataobjs=datasortedset.toArray(a);
	Object[] objs=(Object [])dataobjs.clone();
	for(int i=0;i < dataobjs.length;i++) {
	    objs[i]=toNormalObject(dataobjs[i]);
	}
	return objs;
    }

    public Iterator iterator() {
	return new IteratorAdapter(datasortedset.iterator(),this);
    }

    public boolean containsAll(Collection c) {
	return datasortedset.containsAll(c);
    }
    public boolean remove(Object o) {
	return datasortedset.remove(toPersistentObject(o));
    }

    public boolean removeAll(Collection c) {
	return datasortedset.removeAll(c);
    }

    public boolean retainAll(Collection c) {
	return datasortedset.retainAll(c);
    }

    public int hashCode() {
	return datasortedset.hashCode();
    }

    public Comparator comparator() {
	return datasortedset.comparator();
    }

    public Object first() {
	return toNormalObject(datasortedset.first());
    }

    public Object last() {
	return toNormalObject(datasortedset.last());
    }

    public SortedSet headSet(Object toElement) {
	return datasortedset.headSet(toPersistentObject(toElement));
    }

    public SortedSet subSet(Object fromElement, Object toElement) {
	return datasortedset.subSet(toPersistentObject(fromElement),toPersistentObject(toElement));
    }

    public SortedSet tailSet(Object fromElement) {
	return datasortedset.tailSet(toPersistentObject(fromElement));
    }
}// SortedSetAdapter

